unit World;

interface

uses
  Dialogs;
  
type
  TWorld = class
  private
    FWidth, FHeight: Integer;
    LevelMap: array of array of Boolean;
  public
    constructor Create(Width, Height: Integer);
    destructor Destroy; override;
    function LoadMap(FileName: String): Integer;
    function IsAvailablePos(X, Y: Integer): Boolean;
  end;

implementation

{ TWorld }

constructor TWorld.Create(Width, Height: Integer);
begin
  try
    SetLength(LevelMap, Width, Height);
  except
    ShowMessage('Out of memory for World allocation!');
    Self := nil;
    Exit;
  end;
  FWidth := Width;
  FHeight := Height;
end;

destructor TWorld.Destroy;
begin
  SetLength(LevelMap, 0);
  inherited Destroy;
end;

function TWorld.IsAvailablePos(X, Y: Integer): Boolean;
begin
  if (X < 0) or (X >= FWidth) or (Y < 0) or (Y >= FHeight) then
    Result := False
  else
    Result := not LevelMap[X, Y];
end;

function TWorld.LoadMap(FileName: String): Integer;
var
  I, J: Integer;
begin
  //LevelMap je samo maska koja oznacava kuda moze
  //igrac da se krece u nivou

  for I := 0 to FWidth - 1 do
    for J := 0 to FHeight - 1 do
      LevelMap[I, J] := (I = 0) or (I = FWidth - 1) or (J = 0) or (J = FHeight - 1);

  for I := 0 to 200 do
    for J := 0 to 200 do
      LevelMap[I, J] := True;

  for I := 400 to 600 do
    for J := 0 to 300 do
      LevelMap[I, J] := True;

  for I := 400 to 600 do
    for J := 500 to 600 do
      LevelMap[I, J] := True;

  Result := 1;
end;

end.
